//+------------------------------------------------------------------+
//|                                                        iUSDx.mqh |
//|                                            Copyright 2010, Lizar |
//|                            https://login.mql5.com/ru/users/Lizar |
//|                                              Revision 2010.12.17 |
//+------------------------------------------------------------------+

//           
struct stCurrencyWeight
{
   string symbol;   // 
   double weight;   // 
};

class CUSDx
  {
   protected:
      string   m_symbol;            //    
      int      m_currency_base;     //  
      double   m_currency_weight;   //    
      bool     m_init_flag;
   public:
      double   buffer[]; //    

      void     CUSDx();
      void     SetCurrencyAndWeight(string symbol, double weight);
      void     InitSymbol(int count_symbol, string currency, string symbol);
      void     USDxSymbol(int bar=0);
      bool     GetInit() {return(m_init_flag);}
  };

void CUSDx::CUSDx()
  {
   m_init_flag=false;
  }
  
//+------------------------------------------------------------------+
//|          |
//| INPUT:  symbol - ;                                         |
//|         weight -  .                             |
//| OUTPUT: no.                                                      |
//| REMARK: no.                                                      |
//+------------------------------------------------------------------+
void CUSDx::SetCurrencyAndWeight(string symbol, double weight)
  {
   m_symbol=symbol;
   m_currency_weight=weight;
  }

//+------------------------------------------------------------------+
//|                   |
//| INPUT:  count_symbol   -    ;         |
//|         currency_index -  ;                         |
//|         symbol         -                                   |
//| OUTPUT: no.                                                      |
//| REMARK: no.                                                      |
//+------------------------------------------------------------------+
void CUSDx::InitSymbol(int count_symbol, string currency_index, string symbol)
  {   
   m_init_flag=true;
   
   if(currency_index==SymbolInfoString(m_symbol,SYMBOL_CURRENCY_BASE)) m_currency_base=1;
   else if(currency_index==SymbolInfoString(m_symbol,SYMBOL_CURRENCY_PROFIT)) m_currency_base=-1;
        else m_currency_base=0;

   ArraySetAsSeries(buffer,true);  //    buffer[]     
   
   for(int bar=count_symbol-1; bar>=0; bar--) USDxSymbol(bar);
     
   return;
  }
  
//+------------------------------------------------------------------+
//|               |
//| INPUT:  bar -    .                            |
//| OUTPUT: no.                                                      |
//| REMARK: no.                                                      |
//+------------------------------------------------------------------+
void CUSDx::USDxSymbol(int bar=0)
  {
   buffer[bar]=EMPTY_VALUE;
   if(m_currency_base==0) return;
     
   //      :
   datetime time[1];      
   if(CopyTime(_Symbol,_Period,bar,1,time)!=1) return; //     ...

   //             :
   double price[1];
   if(CopyClose(m_symbol,_Period,time[0],time[0],price)!=1) return; //     ...

   buffer[bar]=MathPow(price[0],m_currency_base*m_currency_weight);
   return;
  }

